Virtual Network Peerings - Create Or Update

Creates or updates a peering in the specified virtual network.

PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/virtualNetworks/{virtualNetworkName}/virtualNetworkPeerings/{virtualNetworkPeeringName}?api-version=2025-05-01
PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/virtualNetworks/{virtualNetworkName}/virtualNetworkPeerings/{virtualNetworkPeeringName}?api-version=2025-05-01&syncRemoteAddressSpace=true

URI Parameters

Name In Required Type Description
resourceGroupName
path True

string

minLength: 1
maxLength: 90

The name of the resource group. The name is case insensitive.

subscriptionId
path True

string (uuid)

The ID of the target subscription. The value must be an UUID.

virtualNetworkName
path True

string

The name of the virtual network.

virtualNetworkPeeringName
path True

string

The name of the virtual network peering.

api-version
query True

string

minLength: 1

The API version to use for this operation.

syncRemoteAddressSpace
query

SyncRemoteAddressSpace

Parameter indicates the intention to sync the peering with the current address space on the remote vNet after it's updated.

Request Body

Name Type Description
id

string

Resource ID.

name

string

Name of the resource.

properties.allowForwardedTraffic

boolean

Whether the forwarded traffic from the VMs in the local virtual network will be allowed/disallowed in remote virtual network.

properties.allowGatewayTransit

boolean

If gateway links can be used in remote virtual networking to link to this virtual network.

properties.allowVirtualNetworkAccess

boolean

Whether the VMs in the local virtual network space would be able to access the VMs in remote virtual network space.

properties.doNotVerifyRemoteGateways

boolean

If we need to verify the provisioning state of the remote gateway.

properties.enableOnlyIPv6Peering

boolean

Whether only Ipv6 address space is peered for subnet peering.

properties.localAddressSpace

Common.AddressSpace

The local address space of the local virtual network that is peered.

properties.localSubnetNames

string[]

List of local subnet names that are subnet peered with remote virtual network.

properties.localVirtualNetworkAddressSpace

Common.AddressSpace

The current local address space of the local virtual network that is peered.

properties.peerCompleteVnets

boolean

Whether complete virtual network address space is peered.

properties.peeringState

VirtualNetworkPeeringState

The status of the virtual network peering.

properties.peeringSyncLevel

VirtualNetworkPeeringLevel

The peering sync status of the virtual network peering.

properties.remoteAddressSpace

Common.AddressSpace

The reference to the address space peered with the remote virtual network.

properties.remoteBgpCommunities

Common.VirtualNetworkBgpCommunities

The reference to the remote virtual network's Bgp Communities.

properties.remoteSubnetNames

string[]

List of remote subnet names from remote virtual network that are subnet peered.

properties.remoteVirtualNetwork

Common.SubResource

The reference to the remote virtual network. The remote virtual network can be in the same or different region (preview). See here to register for the preview and learn more (https://docs.microsoft.com/en-us/azure/virtual-network/virtual-network-create-peering).

properties.remoteVirtualNetworkAddressSpace

Common.AddressSpace

The reference to the current address space of the remote virtual network.

properties.useRemoteGateways

boolean

If remote gateways can be used on this virtual network. If the flag is set to true, and allowGatewayTransit on remote peering is also true, virtual network will use gateways of remote virtual network for transit. Only one peering can have this flag set to true. This flag cannot be set if virtual network already has a gateway.

Responses

Name Type Description
200 OK

Common.VirtualNetworkPeering

Resource 'VirtualNetworkPeering' update operation succeeded

201 Created

Common.VirtualNetworkPeering

Resource 'VirtualNetworkPeering' create operation succeeded

Headers

  • Azure-AsyncOperation: string
  • Retry-After: integer
Other Status Codes

Common.CloudError

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

Create peering
Create peering with remote virtual network encryption
Create subnet peering
Create V6 Subnet peering
Sync Peering
Sync subnet Peering
Sync V6 Subnet Peering

Create peering

Sample request

PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer?api-version=2025-05-01&syncRemoteAddressSpace=true

{
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "useRemoteGateways": false
  }
}

Sample response

{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "peeringState": "Initiated",
    "peeringSyncLevel": "FullyInSync",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8"
      ]
    },
    "useRemoteGateways": false
  }
}
{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "peeringState": "Initiated",
    "peeringSyncLevel": "FullyInSync",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8"
      ]
    },
    "useRemoteGateways": false
  }
}

Create peering with remote virtual network encryption

Sample request

PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer?api-version=2025-05-01&syncRemoteAddressSpace=true

{
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "useRemoteGateways": false
  }
}

Sample response

{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "peeringState": "Initiated",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkEncryption": {
      "enabled": true,
      "enforcement": "AllowUnencrypted"
    },
    "useRemoteGateways": false
  }
}
{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "peeringState": "Initiated",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkEncryption": {
      "enabled": true,
      "enforcement": "AllowUnencrypted"
    },
    "useRemoteGateways": false
  }
}

Create subnet peering

Sample request

PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer?api-version=2025-05-01&syncRemoteAddressSpace=true

{
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "enableOnlyIPv6Peering": false,
    "localSubnetNames": [
      "Subnet1",
      "Subnet4"
    ],
    "peerCompleteVnets": false,
    "remoteSubnetNames": [
      "Subnet2"
    ],
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "useRemoteGateways": false
  }
}

Sample response

{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "enableOnlyIPv6Peering": false,
    "localAddressSpace": {
      "addressPrefixes": [
        "212.0.0.0/16",
        "13.0.0.0/8",
        "2002:2002::/64"
      ]
    },
    "localSubnetNames": [
      "Subnet1",
      "Subnet4"
    ],
    "localVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "212.0.0.0/16",
        "13.0.0.0/8",
        "2002:2002::/64"
      ]
    },
    "peerCompleteVnets": false,
    "peeringState": "Initiated",
    "peeringSyncLevel": "FullyInSync",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8",
        "2001:2001::/64"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteSubnetNames": [
      "Subnet2"
    ],
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8",
        "2001:2001::/64"
      ]
    },
    "useRemoteGateways": false
  }
}
{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "enableOnlyIPv6Peering": false,
    "localAddressSpace": {
      "addressPrefixes": [
        "212.0.0.0/16",
        "13.0.0.0/8",
        "2002:2002::/64"
      ]
    },
    "localSubnetNames": [
      "Subnet1",
      "Subnet4"
    ],
    "localVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "212.0.0.0/16",
        "13.0.0.0/8",
        "2002:2002::/64"
      ]
    },
    "peerCompleteVnets": false,
    "peeringState": "Initiated",
    "peeringSyncLevel": "FullyInSync",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8",
        "2001:2001::/64"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteSubnetNames": [
      "Subnet2"
    ],
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8",
        "2001:2001::/64"
      ]
    },
    "useRemoteGateways": false
  }
}

Create V6 Subnet peering

Sample request

PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer?api-version=2025-05-01&syncRemoteAddressSpace=true

{
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "enableOnlyIPv6Peering": true,
    "localSubnetNames": [
      "Subnet1",
      "Subnet4"
    ],
    "peerCompleteVnets": false,
    "remoteSubnetNames": [
      "Subnet2"
    ],
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "useRemoteGateways": false
  }
}

Sample response

{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "enableOnlyIPv6Peering": true,
    "localAddressSpace": {
      "addressPrefixes": [
        "2002::/64",
        "2003::/64"
      ]
    },
    "localSubnetNames": [
      "Subnet1",
      "Subnet4"
    ],
    "localVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "2002::/64",
        "2003::/64"
      ]
    },
    "peerCompleteVnets": false,
    "peeringState": "Initiated",
    "peeringSyncLevel": "FullyInSync",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "2001::/64"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteSubnetNames": [
      "Subnet2"
    ],
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "2001::/64"
      ]
    },
    "useRemoteGateways": false
  }
}
{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "enableOnlyIPv6Peering": true,
    "localAddressSpace": {
      "addressPrefixes": [
        "2002::/64",
        "2003::/64"
      ]
    },
    "localSubnetNames": [
      "Subnet1",
      "Subnet4"
    ],
    "localVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "2002::/64",
        "2003::/64"
      ]
    },
    "peerCompleteVnets": false,
    "peeringState": "Initiated",
    "peeringSyncLevel": "FullyInSync",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "2001::/64"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteSubnetNames": [
      "Subnet2"
    ],
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "2001::/64"
      ]
    },
    "useRemoteGateways": false
  }
}

Sync Peering

Sample request

PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer?api-version=2025-05-01&syncRemoteAddressSpace=true

{
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "useRemoteGateways": false
  }
}

Sample response

{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "peeringState": "Initiated",
    "peeringSyncLevel": "FullyInSync",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8"
      ]
    },
    "useRemoteGateways": false
  }
}
{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "peeringState": "Initiated",
    "peeringSyncLevel": "FullyInSync",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8"
      ]
    },
    "useRemoteGateways": false
  }
}

Sync subnet Peering

Sample request

PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer?api-version=2025-05-01&syncRemoteAddressSpace=true

{
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "enableOnlyIPv6Peering": false,
    "peerCompleteVnets": false,
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "useRemoteGateways": false
  }
}

Sample response

{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "enableOnlyIPv6Peering": false,
    "localAddressSpace": {
      "addressPrefixes": [
        "212.0.0.0/16",
        "2002:2002::/64"
      ]
    },
    "localSubnetNames": [
      "Subnet1"
    ],
    "localVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "212.0.0.0/16",
        "2002:2002::/64"
      ]
    },
    "peerCompleteVnets": false,
    "peeringState": "Initiated",
    "peeringSyncLevel": "FullyInSync",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8",
        "2001:2001::/64"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteSubnetNames": [
      "Subnet2"
    ],
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8",
        "2001:2001::/64"
      ]
    },
    "useRemoteGateways": false
  }
}
{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "enableOnlyIPv6Peering": false,
    "localAddressSpace": {
      "addressPrefixes": [
        "212.0.0.0/16",
        "2002:2002::/64"
      ]
    },
    "localSubnetNames": [
      "Subnet1"
    ],
    "localVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "212.0.0.0/16",
        "2002:2002::/64"
      ]
    },
    "peerCompleteVnets": false,
    "peeringState": "Initiated",
    "peeringSyncLevel": "FullyInSync",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8",
        "2001:2001::/64"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteSubnetNames": [
      "Subnet2"
    ],
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "12.0.0.0/8",
        "2001:2001::/64"
      ]
    },
    "useRemoteGateways": false
  }
}

Sync V6 Subnet Peering

Sample request

PUT https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer?api-version=2025-05-01&syncRemoteAddressSpace=true

{
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "enableOnlyIPv6Peering": true,
    "peerCompleteVnets": false,
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "useRemoteGateways": false
  }
}

Sample response

{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "enableOnlyIPv6Peering": true,
    "localAddressSpace": {
      "addressPrefixes": [
        "2002:2002::/64"
      ]
    },
    "localSubnetNames": [
      "Subnet1"
    ],
    "localVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "2002:2002::/64"
      ]
    },
    "peerCompleteVnets": false,
    "peeringState": "Initiated",
    "peeringSyncLevel": "FullyInSync",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "2001:2001::/64"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteSubnetNames": [
      "Subnet2"
    ],
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "2001:2001::/64"
      ]
    },
    "useRemoteGateways": false
  }
}
{
  "name": "peer",
  "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet1/virtualNetworkPeerings/peer",
  "properties": {
    "allowForwardedTraffic": true,
    "allowGatewayTransit": false,
    "allowVirtualNetworkAccess": true,
    "enableOnlyIPv6Peering": true,
    "localAddressSpace": {
      "addressPrefixes": [
        "2002:2002::/64"
      ]
    },
    "localSubnetNames": [
      "Subnet1"
    ],
    "localVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "2002:2002::/64"
      ]
    },
    "peerCompleteVnets": false,
    "peeringState": "Initiated",
    "peeringSyncLevel": "FullyInSync",
    "provisioningState": "Succeeded",
    "remoteAddressSpace": {
      "addressPrefixes": [
        "2001:2001::/64"
      ]
    },
    "remoteBgpCommunities": {
      "regionalCommunity": "12076:50004",
      "virtualNetworkCommunity": "12076:20002"
    },
    "remoteSubnetNames": [
      "Subnet2"
    ],
    "remoteVirtualNetwork": {
      "id": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/peerTest/providers/Microsoft.Network/virtualNetworks/vnet2"
    },
    "remoteVirtualNetworkAddressSpace": {
      "addressPrefixes": [
        "2001:2001::/64"
      ]
    },
    "useRemoteGateways": false
  }
}

Definitions

Name Description
Common.AddressSpace

AddressSpace contains an array of IP address ranges that can be used by subnets of the virtual network.

Common.CloudError

An error response from the service.

Common.CloudErrorBody

An error response from the service.

Common.IpamPoolPrefixAllocation

IpamPool prefix allocation reference.

Common.SubResource

Reference to another subresource.

Common.VirtualNetworkBgpCommunities

Bgp Communities sent over ExpressRoute with each route corresponding to a prefix in this VNET.

Common.VirtualNetworkEncryption

Indicates if encryption is enabled on virtual network and if VM without encryption is allowed in encrypted VNet.

Common.VirtualNetworkPeering

Peerings in a virtual network resource.

ProvisioningState

The provisioning state of the application security group resource.

SyncRemoteAddressSpace

Parameter indicates the intention to sync the peering with the current address space on the remote vNet after it's updated.

VirtualNetworkEncryptionEnforcement

If the encrypted VNet allows VM that does not support encryption. This field is for future support, AllowUnencrypted is the only supported value at general availability.

VirtualNetworkPeeringLevel

The peering sync status of the virtual network peering.

VirtualNetworkPeeringState

The status of the virtual network peering.

Common.AddressSpace

AddressSpace contains an array of IP address ranges that can be used by subnets of the virtual network.

Name Type Description
addressPrefixes

string[]

A list of address blocks reserved for this virtual network in CIDR notation.

ipamPoolPrefixAllocations

Common.IpamPoolPrefixAllocation[]

A list of IPAM Pools allocating IP address prefixes.

Common.CloudError

An error response from the service.

Name Type Description
error

Common.CloudErrorBody

Cloud error body.

Common.CloudErrorBody

An error response from the service.

Name Type Description
code

string

An identifier for the error. Codes are invariant and are intended to be consumed programmatically.

details

Common.CloudErrorBody[]

A list of additional details about the error.

message

string

A message describing the error, intended to be suitable for display in a user interface.

target

string

The target of the particular error. For example, the name of the property in error.

Common.IpamPoolPrefixAllocation

IpamPool prefix allocation reference.

Name Type Description
allocatedAddressPrefixes

string[]

List of assigned IP address prefixes in the IpamPool of the associated resource.

numberOfIpAddresses

string

Number of IP addresses to allocate.

pool.id

string (arm-id)

Resource id of the associated Azure IpamPool resource.

Common.SubResource

Reference to another subresource.

Name Type Description
id

string

Resource ID.

Common.VirtualNetworkBgpCommunities

Bgp Communities sent over ExpressRoute with each route corresponding to a prefix in this VNET.

Name Type Description
regionalCommunity

string

The BGP community associated with the region of the virtual network.

virtualNetworkCommunity

string

The BGP community associated with the virtual network.

Common.VirtualNetworkEncryption

Indicates if encryption is enabled on virtual network and if VM without encryption is allowed in encrypted VNet.

Name Type Description
enabled

boolean

Indicates if encryption is enabled on the virtual network.

enforcement

VirtualNetworkEncryptionEnforcement

If the encrypted VNet allows VM that does not support encryption. This field is for future support, AllowUnencrypted is the only supported value at general availability.

Common.VirtualNetworkPeering

Peerings in a virtual network resource.

Name Type Description
etag

string

A unique read-only string that changes whenever the resource is updated.

id

string

Resource ID.

name

string

Name of the resource.

properties.allowForwardedTraffic

boolean

Whether the forwarded traffic from the VMs in the local virtual network will be allowed/disallowed in remote virtual network.

properties.allowGatewayTransit

boolean

If gateway links can be used in remote virtual networking to link to this virtual network.

properties.allowVirtualNetworkAccess

boolean

Whether the VMs in the local virtual network space would be able to access the VMs in remote virtual network space.

properties.doNotVerifyRemoteGateways

boolean

If we need to verify the provisioning state of the remote gateway.

properties.enableOnlyIPv6Peering

boolean

Whether only Ipv6 address space is peered for subnet peering.

properties.localAddressSpace

Common.AddressSpace

The local address space of the local virtual network that is peered.

properties.localSubnetNames

string[]

List of local subnet names that are subnet peered with remote virtual network.

properties.localVirtualNetworkAddressSpace

Common.AddressSpace

The current local address space of the local virtual network that is peered.

properties.peerCompleteVnets

boolean

Whether complete virtual network address space is peered.

properties.peeringState

VirtualNetworkPeeringState

The status of the virtual network peering.

properties.peeringSyncLevel

VirtualNetworkPeeringLevel

The peering sync status of the virtual network peering.

properties.provisioningState

ProvisioningState

The provisioning state of the virtual network peering resource.

properties.remoteAddressSpace

Common.AddressSpace

The reference to the address space peered with the remote virtual network.

properties.remoteBgpCommunities

Common.VirtualNetworkBgpCommunities

The reference to the remote virtual network's Bgp Communities.

properties.remoteSubnetNames

string[]

List of remote subnet names from remote virtual network that are subnet peered.

properties.remoteVirtualNetwork

Common.SubResource

The reference to the remote virtual network. The remote virtual network can be in the same or different region (preview). See here to register for the preview and learn more (https://docs.microsoft.com/en-us/azure/virtual-network/virtual-network-create-peering).

properties.remoteVirtualNetworkAddressSpace

Common.AddressSpace

The reference to the current address space of the remote virtual network.

properties.remoteVirtualNetworkEncryption

Common.VirtualNetworkEncryption

The reference to the remote virtual network's encryption

properties.resourceGuid

string

The resourceGuid property of the Virtual Network peering resource.

properties.useRemoteGateways

boolean

If remote gateways can be used on this virtual network. If the flag is set to true, and allowGatewayTransit on remote peering is also true, virtual network will use gateways of remote virtual network for transit. Only one peering can have this flag set to true. This flag cannot be set if virtual network already has a gateway.

type

string

Resource type.

ProvisioningState

The provisioning state of the application security group resource.

Value Description
Failed

Failed

Succeeded

Succeeded

Canceled

Canceled

Creating

Creating

Updating

Updating

Deleting

Deleting

SyncRemoteAddressSpace

Parameter indicates the intention to sync the peering with the current address space on the remote vNet after it's updated.

Value Description
true

true

VirtualNetworkEncryptionEnforcement

If the encrypted VNet allows VM that does not support encryption. This field is for future support, AllowUnencrypted is the only supported value at general availability.

Value Description
DropUnencrypted

DropUnencrypted

AllowUnencrypted

AllowUnencrypted

VirtualNetworkPeeringLevel

The peering sync status of the virtual network peering.

Value Description
FullyInSync

FullyInSync

RemoteNotInSync

RemoteNotInSync

LocalNotInSync

LocalNotInSync

LocalAndRemoteNotInSync

LocalAndRemoteNotInSync

VirtualNetworkPeeringState

The status of the virtual network peering.

Value Description
Initiated

Initiated

Connected

Connected

Disconnected

Disconnected